<?php
/**
 * Created by PhpStorm.
 * User: carinaoliveira
 * Date: 28/08/14
 * Time: 15:35
 */

namespace Financeiro\Logic\TalaoCheque;

use Financeiro\Entities\Cheque;
use Setforms2\Shared\Registry;


class Cheques {

    public static function insereCheque($campos) {
        $db = \Setforms2\Runtime\Connection::getInstance();
        $db->getConn()->beginTransaction();
        $connection = Registry::getEntityManager();

        try {

            $cheque = new Cheque();
            $cheque->setCdreducont($campos['CDREDUCONT']);
            $cheque->setNrcheque($campos['NRCHEQUE']);
            $cheque->setIdstcheque($campos['IDSTCHEQUE']);
            $cheque->setNrorg($campos['NRORG']);
            $cheque->setIdativo($campos['IDATIVO']);
            $cheque->setDtultatu($campos['DTULTATU']);
            $cheque->setCdoperultatu($campos['CDOPERULTATU']);
            $cheque->setNrorgultatu($campos['NRORGULTATU']);
            $cheque->setDtinclusao($campos['DTINCLUSAO']);
            $cheque->setCdoperinclusao($campos['CDOPERINCLUSAO']);
            $cheque->setNrorginclusao($campos['NRORGINCLUSAO']);

            $cheque->persist();

            $connection->flush();
            $db->commit();

        } catch (\Exception $e) {
            $db->rollback();
            throw $e;
        }

    }

    public static function deletaCheques($cdreducont, $nrChequeInic, $nrChequeFina, $nrorg){

        try {
            $cheques = Cheque::getObjectsByWhere(
                '(CDREDUCONT = ?) AND
                 (NRCHEQUE BETWEEN ? AND ? ) AND (NRORG = ?)',
                array($cdreducont,
                    $nrChequeInic,
                    $nrChequeFina,
                    $nrorg)
            );

            /** @var $cheque Cheque */
            foreach ($cheques as $cheque) {
                $cheque->delete();
            }
            Registry::getEntityManager()->flush();
        } catch (\Exception $e) {
            throw $e;
        }

    }

} 